### 단순연결리스트 삽입 : 일반버전
memory = []
head, current, pre = None, None, None
dataArray = ['다현', '정연', '쯔위', '사나', '지효']

class Node:
    def __init__(self):
        self.data = None
        self.link = None

def printNodes(start):
    """ 출력 함수 """
    current = start
    if current == None:
        return
    print(current.data, end='->')
    while current.link != None:
        current = current.link
        print(current.data, end='->')
    print()

def insertNode(findData, insertData):
    """ 삽입 함수 """
    global head, current, pre
    ## 첫번째 노드 삽입
    if head.data == findData:
        node = Node()
        node.data = insertData
        node.link = head  # 링크를 헤드가 가리키는 노드로 지정
        head = node  # 헤드를 새 노드로 변경
        return

    ## 중간 노드 삽입
    current = head
    while current.link != None:  # 현재 노드가 마지막이 아닐때까지 반복
        pre = current  # 현재 노드를 이전 노드로 지정
        current = current.link
        if current.data == findData:
            node = Node()
            node.data = insertData
            node.link = current
            pre.link = node
            return

    ## 마지막 노드 삽입(찾는 데이터가 메모리에 없다면)
    node = Node()
    node.data = insertData
    current.link = node

if __name__ == '__main__':
    node = Node()
    node.data = dataArray[0]
    head = node
    memory.append(node)

    for data in dataArray[1:]:
        pre = node  # 현재 노드를 이전 노드로 지정
        node = Node()  # 새 노드 생성
        node.data = data
        pre.link = node  # 이전 노드의 링크에 새 노드를 대입
        memory.append(node)

    printNodes(head)

    insertNode('다현', '화사')  # 첫번째 노드 삽입 경우
    printNodes(head)

    insertNode('사나', '솔라')  # 중간에 노드 삽입 경우
    printNodes(head)

    insertNode('재남', '문별')  # 맨 뒤 노드 삽입 경우
    printNodes(head)